'Binary Clock
'Use 2 x PCF8574 
'Connect LEDs from low to high ie P0 is led 1 P7 is the seconds flashing led


I2CEN 100,100 ' Enable I2C
I2CAddr  = &H20        ' this is the Minutes 8574 I2C address
                       ' A2=A1=A0=0 <-> x100 000x
' Hours 8574 address is set to H21
' A0=1 A1=A2=0  
Print Time$

Main:

HoursTens = Val(Mid$(Time$, 1, 1))
HoursUnits= Val(Mid$(Time$, 2, 1))
MinutesTens= Val(Mid$(Time$, 4, 1))
MinutesUnits= Val(Mid$(Time$, 5, 1))
SecondsUnits = Val(Mid$(Time$, 7, 2))

MinT = Invert(Rotl(MinutesTens,4))
MinU = Invert(MinutesUnits)
Minutes =(MinT And MinU)

HourT = Invert(Rotl(HoursTens,4))
HourU = Invert(HoursUnits)
Hours = (HourT And HourU)

If SecondsUnits Mod 2 = 0 Then
Minutes = Minutes And &B01111111
EndIf

I2CSEND i2caddr, 0, 1, Minutes          ' send to Minutes 8574"
I2CSEND i2caddr+1, 0, 1, Hours		' send to Hours 8574


GoTo Main

End


Function Invert(byte_in)
  'Inverts bits in the byte
  Invert = byte_in Xor &hFF
End Function


Function RotL(byte_in, rot)
  ' Rotates (circular shift) bits left by given quantity
  If rot < 1 Or rot > 7 Then Error "Invalid rotate value"
  RotL = ((byte_in * 2 ^ rot) + ((byte_in * 2 ^ rot)\&h100)) And &hFF
End Function




                                                                                      